from concurrent.futures import ThreadPoolExecutor
import re,os,rsa,wmi,uuid
from Crypto.Cipher import AES
from binascii import b2a_hex, a2b_hex
from hashlib import md5
from .sx import *
import time,sys
import win32clipboard
import win32con
from PIL import Image
from io import BytesIO
#需要第三方包的模块

class AES_128_CBC():
    def __init__(self, key:bytes,iv:bytes):
        '''
        :param key: 长度16位的bytes
        :param iv: 长度16位的bytes
        '''
        self.key = key
        self.iv=iv
        self.mode = AES.MODE_CBC
    # 这里密钥key 长度必须为16（AES-128）、24（AES-192）、或32（AES-256）Bytes 长度.目前AES-128足够用
    # 如果text不足16位的倍数就用空格补足为16位
    def add_to_16(self,text):
        if len(text.encode('utf-8')) % 16:
            add = 16 - (len(text.encode('utf-8')) % 16)
        else:
            add = 0
        text = text + ('\0' * add)
        return text.encode('utf-8')
        # 加密函数
    def encrypt(self,text):
        cryptos = AES.new(self.key, self.mode, self.iv)
        cipher_text = cryptos.encrypt(self.add_to_16(text))
        # 因为AES加密后的字符串不一定是ascii字符集的，输出保存可能存在问题，所以这里转为16进制字符串
        return b2a_hex(cipher_text).decode()    #b2a_hex 字符串转成16进制
    # 解密后，去掉补足的空格用strip() 去掉
    def decrypt(self,text):
        cryptos = AES.new(self.key, self.mode, self.iv)
        plain_text = cryptos.decrypt(a2b_hex(text)) #a2b_hex ascii转成bytes
        return bytes.decode(plain_text).rstrip('\0')
class RSA():
    def 创建秘钥(self):
        # 生成公钥、私钥
        (pubkey, privkey) = rsa.newkeys(512)
        return (pubkey,privkey)
    def 加密(self,s,pubkey):#公钥
        # 明文编码格式
        content = s.encode("utf-8")
        crypto = rsa.encrypt(content, pubkey)
        return crypto
    def 解密(self,s, privkey):#私钥
        content = rsa.decrypt(s, privkey)
        con = content.decode("utf-8")
        return con
class DOWN_M3U8():
    def __init__(self, 文件路径='test.mp4', 网址='', m3u8字符串='', TS地址回调函数=None, 线程数=20,show=False, istest=False,显示解码=True,二进制=True,try_num=10, 类型=1):
        # 链接地址回调 可以调整ts链接
        if 类型==1:
            self.url = 网址
        elif 类型==2:
            #无加密视频网址
            print('[ {} ]'.format(scolor('测试无加密模式')))
            self.url = 'https://hls.videocc.net/source/24560c93d4/d/24560c93d4c855d66ab155af0db215d1_1.m3u8'
        elif 类型==3:
            #加密视频网址
            print('[ {} ]'.format(scolor('测试加密模式')))
            self.url= 'https://cd15-ccd1-2.play.bokecc.com/flvs/0DD1F081022C163E/2021-02-23/0642A98932599FAF9C33DC5901307461-20.m3u8?t=1635076402&key=E45B49E325D8B1C425133DC317308BDE&tpl=10&tpt=112'
            self.url = 'https://1258712167.vod2.myqcloud.com/25121a6avodtransbj1258712167/9d02b67b5285890800144111742/drm/voddrm.token.dWluPTt2b2RfdHlwZT0yO2NpZD0xMDkxMTA7cHNrZXk9O2V4dD0=.v.f30741.m3u8?t=619caf12&exper=0&us=2673142424772967461&sign=5ed90abe3dd10924416a7f996447ea11'
        else:
            print('[ {} ]'.format(scolor('测试 文本+视频链接 模式')))
            self.url='https://hls.videocc.net/source/24560c93d4/d/24560c93d4c855d66ab155af0db215d1_1.m3u8'
            m3u8字符串=get_request(self.url).text

        self.fpath=文件路径
        self.fname=os.path.split(文件路径)[1]
        self.try_num=try_num #失败次数

        self.items=[]  #存所有的ts地址
        self.cookie=None
        self.proxies=None
        self.headers={'User-Agent':'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.25 Safari/537.36 Core/1.70.3732.400 QQBrowser/10.5.3819.400'}

        self.加密信息 = {}  # 存加密信息
        self.线程数 = 线程数  # 线程数
        self.TS地址回调函数=TS地址回调函数
        self.进度条回调函数=None #回调进度条
        self.m3u8字符串= ''  #m3u8内容
        self.加密行= ''
        self.AES对象 = None
        self.打印TS链接 = False
        self.istest=istest
        self.key=None
        self.iv=None
        self.二进制=二进制
        self.显示解码=显示解码

        self.m3u8字符串 = m3u8字符串.strip()
        self.state=True  #是否正常获取视频信息
        self.show=show  #显示text
        self.testlen=10
    def get_items(self):
        try:
            if self.m3u8字符串:
                lines=self.m3u8字符串
                if self.show:
                    print('[ {} ] [ {} ] : {}'.format(scolor('文本'),scolor('视频链接'), self.url if self.url else '无视频链接'))
            else:
                if self.show:
                    print('[ {} ] : {}'.format(scolor('视频链接'), self.url))
                lines = self.get_url(self.url).text  # 获取M3U8的文件内容
                self.m3u8字符串 = lines
            # 读取文件里的每一行
            file_line = lines.split("\n")
            # 通过判断文件头来确定是否是M3U8文件
            if '#EXTM3U' not in file_line[0].upper():
                raise Exception('非M3U8的链接')
            else:

                key_line = re.search('(#EXT-X-KEY:.*?)\n', lines)
                #加密信息行
                if key_line:
                    self.加密行=key_line.group(1)
                    try:
                        self.加密信息=dict([[y.strip('"') for y in x.split('=',1)] for x in self.加密行.split(':',1)[1].split(',')])
                    except:
                        self.加密信息=None
                #无加密
                else:
                    self.加密信息 = None

                unknow = True  # 用来判断是否找到了下载的地址
                n = 1
                for index, line in enumerate(file_line):
                    if "EXTINF" in line:
                        unknow = False
                        ts_url=file_line[index+1]
                        if self.TS地址回调函数:  # 如果设置了回调
                            # def TS地址回调函数(line):return url
                            ts_url = self.TS地址回调函数(ts_url)
                        else:
                            #没有http头 如果是网址 则拼接
                            if 'http' not in ts_url and self.url:
                                ts_url = self.url.rsplit("/", 1)[0] + "/" + ts_url
                        if self.打印TS链接:
                            print(ts_url)
                        self.items.append({'i':n, 'url':ts_url})
                        n+=1

                if unknow:
                    raise Exception("没有ts链接")
        except BaseException as e:
            print('[ {} ]'.format(scolor('获取视频信息 : {} {}'.format(';'.join(e.args),e.__traceback__.tb_lineno),'err')))
            self.state=False
    def get_aes(self):
        # 如果有加密 则简单的解密
        # 如果复杂的加密 请覆盖 KEY cryptor 还有items
        if self.state:
            if self.加密信息:
                try:
                    # 如果没有加密器 自动合成一个

                    if self.AES对象:
                        print('[ {} ]'.format(scolor('加载自定义AES')))
                    else:
                        if not self.key:
                            self.key = get_request(self.加密信息['URI'], proxies=self.proxies, allow_redirects=True,
                                                   verify=False, try_num=self.try_num).content  # 不加headers
                            if len(self.key)!=16:
                                self.key = self.get_url(self.加密信息['URI']).content  # 加headers
                            if len(self.key)!=16:
                                raise Exception('aes len {}'.format(len(self.key)))
                        if self.iv:
                            # 自定义iv
                            pass
                        else:
                            if 'IV' in self.加密信息:
                                if not self.iv:
                                    if len(self.加密信息['IV']) == 34:
                                        # 16进制转成字节
                                        self.iv = bytes.fromhex(self.加密信息['IV'][2:])
                                    else:
                                        self.iv = self.加密信息['IV'][:16].encode()
                            else:
                                self.iv = self.key

                        self.AES对象 = AES.new(self.key, AES.MODE_CBC, self.iv)
                        if self.显示解码:
                            print('[ {} ]'.format(scolor('解码成功')),end=' ')
                except Exception as e:
                    if self.显示解码:
                        print('[ {} ]'.format(scolor('解码失败 : {}'.format(e.args[0]), 'err')))
                    self.state=False
            else:
                if self.显示解码:
                    print('[ {} ]'.format(scolor('无加密')),end=' ')
    def get_url(self, url,try_num=None):
        try:
            return get_request(url, cookies=self.cookie, headers=self.headers, proxies=self.proxies, allow_redirects=True, verify=False, try_num=try_num if try_num else self.try_num)
        except Exception as e:
            raise Exception('获取链接错误 : {}'.format(e.args),'tools第{}行'.format(e.__traceback__.tb_lineno))
    def download_ts(self,item):
        for i in range(self.try_num):
            try:
                req=self.get_url(item['url'],try_num=1)
                size=req.headers['content-length']
                content=req.content
                if self.AES对象:#如果有加密
                    content = self.AES对象.decrypt(content)
                #item['i'] 已有
                item['size']=int(size)
                item['content']=content
                return item
            except Exception as e:
                pass
        return None
    def run(self):
        try:
            self.get_aes()
            isdone=True
            if self.items and self.state:
                print('[ {} ] : {}'.format(scolor('保存路径', 'warn'), scolor(self.fpath, 'yes')))
                self.开始时间=time.time()
                self.已下载大小=0
                self.进度 = 0  # 统计进度条
                pool=ThreadPoolExecutor(self.线程数)
                self.items=self.items[:self.testlen] if self.istest else self.items
                self.count = len(self.items)

                data={}
                L=len(self.items)
                def callback(rt):
                    item = rt.result()
                    if item:
                        data[item['i']] = item['content']
                        self.已下载大小 += item['size']
                        t=time.time()-self.开始时间
                        剩余时间 ='' if self.进度+1==L else ' {:.2f}S'.format(t * L / (self.进度+1)-t )
                        speed = '{:.2f}MB/S{}'.format(self.已下载大小 / 1024 / 1024 / t,剩余时间)
                        fsize='{:.2f}MB'.format(self.已下载大小 / 1024 / 1024)
                        if self.进度条回调函数:
                            #'{}    {} {}/{} {} {}'.format(rt['name'],rt['bfb'], rt['i'],rt['count'],rt['size'],rt['speed'])
                            self.进度条回调函数({'name':self.fname,'bfb':'{}%'.format(int((self.进度+1)/self.count*100)),'size':fsize, 'i':self.进度+1, 'count':self.count,'speed':speed})
                        else:
                            打印_进度条(fsize, self.进度, self.count, 1, speed, 类型=4)
                        self.进度 += 1
                    else:
                        nonlocal isdone
                        isdone=False
                tasks=[]
                for item in self.items:
                    tasks.append(pool.submit(self.download_ts,item).add_done_callback(callback))
                pool.shutdown(wait=True)
                if os.path.exists(self.fpath):
                    os.remove(self.fpath)
                # 只有全部完成才保存
                if isdone:
                    data = sorted(data.items(), key=lambda d: d[0], reverse=False)
                    if self.二进制:
                        with open(self.fpath,'wb') as f:
                            for d in data:
                                f.write(d[1])
                    else:
                        path = os.path.join(HOME_PATH, "视频缓存")
                        if not os.path.exists(path):
                            os.makedirs(path, exist_ok=1)
                        #获取顺序文件
                        files=[]
                        for i,d in enumerate(data):
                            fpath=os.path.join(path,'{}.ts'.format(i))
                            with open(fpath,'wb') as f:
                                f.write(d[1])
                                files.append(fpath)
                        ff=FFMPEG()
                        ff.合并视频(文件路径=self.fpath, 视频列表=files)
                        import shutil
                        shutil.rmtree(path)
                del tasks
                del data
                print()
            else:
                isdone=False
            return isdone
        except BaseException as e:
            print()
            打印错误(e)
            return False
class 剪切板():
    def __init__(self):
        pass
    def 复制文本(self,字符串):
        win32clipboard.OpenClipboard()
        win32clipboard.EmptyClipboard()
        win32clipboard.SetClipboardData(win32con.CF_UNICODETEXT, 字符串)
        win32clipboard.CloseClipboard()
    def 粘贴文本(self):
        win32clipboard.OpenClipboard()
        text = win32clipboard.GetClipboardData(win32con.CF_UNICODETEXT)
        win32clipboard.CloseClipboard()
        return text
    def 复制图片(self,图片路径):
        if os.path.exists(图片路径):
            imagepath = 图片路径
            img = Image.open(imagepath)  # Image.open可以打开网络图片与本地图片。
            output = BytesIO()  # BytesIO实现了在内存中读写bytes
            img.convert("RGB").save(output, "BMP")  # 以RGB模式保存图像
            data = output.getvalue()[14:]
            output.close()
            win32clipboard.OpenClipboard()  # 打开剪贴板
            win32clipboard.EmptyClipboard()  # 先清空剪贴板
            win32clipboard.SetClipboardData(win32con.CF_DIB, data)  # 将图片放入剪贴板
            win32clipboard.CloseClipboard()
def 获取_电脑信息():
    c=wmi.WMI()
    dic = {'cpu': c.Win32_Processor(),
           '硬盘': c.Win32_DiskDrive(),
           '主板': c.Win32_BaseBoard(),
           'bios': c.Win32_BIOS(),
           '电池': c.Win32_Battery(),
           '网卡': c.Win32_NetworkAdapter()
           }
    dic_new = {}
    for k, v in dic.items():
        dic_new[k] = []
        for x in v:
            dic_new[k].append(dict(re.findall('(\w+) = (.*?);', str(x))))
    return dic_new
def 获取_机器码(加密字符串=None,类型=1):
    c=wmi.WMI()
    info={}
    主板=c.Win32_BaseBoard()[0]
    if 类型==1:    #绑定主板
        info['主板型号'] = 主板.Product.strip()
        info['主板UUID'] = 主板.qualifiers['UUID'].strip()
    elif 类型==2:  #绑定主板+网卡
        info['主板型号'] = 主板.Product.strip()
        info['主板UUID'] = 主板.qualifiers['UUID'].strip()
        info['网卡地址']=str(uuid.uuid1()).split('-')[-1].strip()
    if 加密字符串:
        info['加密字符串'] = str(加密字符串)
    return md5(str(info).encode("utf-8")).hexdigest()
